/*
 * GeneralSort.java
 */

public class GeneralSort {

  public GeneralSort() {}

  /**
   * A generalized sort that works for all classes that implements the
   * AnythingComparable interface.
   */
  public void bubbleSort( AnythingComparable a[] )
  {
    int left = 0;
    while( left < a.length-1 )
    {
      int index = left;
      for( int i=left ; i < a.length ; ++i )
        if( a[i].lessThan(a[index]) ) index = i;

      // swap a[index] and a[left]
      AnythingComparable tmp = a[index];
      a[index] = a[left];
      a[left] = tmp;

      ++left;
    }    
  }

  public static void main( String args[] )
  {
    SomethingComparable s[] = new SomethingComparable[10];
    for( int i=0 ; i < s.length ; ++i )
    {
      s[i] = new SomethingComparable( (int)(Math.random()*15) + 1 );
      System.out.println( s[i] );
    }

    (new GeneralSort()).bubbleSort(s);
    System.out.println("-----------------------------------");

    for( int i=0 ; i < s.length ; ++i )
      System.out.println( s[i] );
  }

} // end of class GeneralSort

